commit 27cc5fdaa9d3aaaa1e8a21ec7481740443d1d18f
Author: freddy77 <freddy77>
Date:   Sat Jul 3 08:53:13 2010 +0000

    fix return codes from replacement iconv

diff --git a/ChangeLog b/ChangeLog
index 9a6fb71..f1d23be 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sat Jul  3 10:53:03 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/replacements/iconv.c: fix return codes from replacement iconv
+
 Sat Jul  3 08:57:50 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* configure.ac src/replacements/iconv.c:
 	- rewrote iconv replacement adding support for ucs4
@@ -2574,4 +2577,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3054 2010/07/03 06:57:56 freddy77 Exp $
+$Id: ChangeLog,v 1.3055 2010/07/03 08:53:13 freddy77 Exp $
diff --git a/src/replacements/iconv.c b/src/replacements/iconv.c
index 0ea8445..b6d79e2 100644
--- a/src/replacements/iconv.c
+++ b/src/replacements/iconv.c
@@ -49,7 +49,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.18 2010/07/03 06:57:56 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.19 2010/07/03 08:53:13 freddy77 Exp $");
 
 /**
  * \addtogroup conv
@@ -203,7 +203,7 @@ static int
 put_ucs2le(unsigned char *buf, int buf_len, ICONV_CHAR c)
 {
 	if (c >= 0x10000u)
-		return -EINVAL;
+		return -EILSEQ;
 	if (buf_len < 2)
 		return -E2BIG;
 	TDS_PUT_A2LE(buf, c);
@@ -223,7 +223,7 @@ static int
 put_ucs2be(unsigned char *buf, int buf_len, ICONV_CHAR c)
 {
 	if (c >= 0x10000u)
-		return -EINVAL;
+		return -EILSEQ;
 	if (buf_len < 2)
 		return -E2BIG;
 	TDS_PUT_A2BE(buf, c);
@@ -243,7 +243,7 @@ static int
 put_iso1(unsigned char *buf, int buf_len, ICONV_CHAR c)
 {
 	if (c >= 0x100u)
-		return -EINVAL;
+		return -EILSEQ;
 	if (buf_len < 1)
 		return -E2BIG;
 	buf[0] = (unsigned char) c;
@@ -265,7 +265,7 @@ static int
 put_ascii(unsigned char *buf, int buf_len, ICONV_CHAR c)
 {
 	if (c >= 0x80u)
-		return -EINVAL;
+		return -EILSEQ;
 	if (buf_len < 1)
 		return -E2BIG;
 	buf[0] = (unsigned char) c;
@@ -281,7 +281,7 @@ get_err(const unsigned char *p, int len, ICONV_CHAR *out)
 static int
 put_err(unsigned char *buf, int buf_len, ICONV_CHAR c)
 {
-	return -EINVAL;
+	return -EILSEQ;
 }
 
 typedef int (*iconv_get_t)(const unsigned char *p, int len,     ICONV_CHAR *out);
@@ -410,7 +410,7 @@ tds_sys_iconv (iconv_t cd, const char* * inbuf, size_t *inbytesleft, char* * out
 
 			written = put_func(ob, ol, out_c);
 			if (TDS_UNLIKELY(written < 0)) {
-				local_errno = -readed;
+				local_errno = -written;
 				break;
 			}
 			il -= readed;

